/*
 * <license>
 * 
 * Controller v2.1
 * 
 * This software is provided to enhance knowledge and encourage progress in the scientific
 * community. It should be used only for research and educational purposes. Any reproduction
 * or use for commercial purpose, public redistribution, in source or binary forms, with or 
 * without modifications, is NOT ALLOWED without the previous authorization of the copyright 
 * holder. The origin of this software must not be misrepresented; you must not claim that you
 * wrote the original software. If you use this software for any purpose (e.g. publication),
 * a reference to the software package and the authors must be included.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * Copyright (c) 2007-2020, Trasgo Group, Universidad de Valladolid.
 * All rights reserved.
 * 
 * More information on http://trasgo.infor.uva.es/
 * 
 * </license>
*/
#ifndef _CTRL_CUDA_TILE_H_
#define _CTRL_CUDA_TILE_H_

#include <stdbool.h>

#include <cuda_runtime_api.h>

#include "Architectures/Cuda/Ctrl_Cuda.h"


typedef struct Ctrl_Cuda_Tile {
    struct Ctrl_Cuda                *p_ctrl;

    struct Ctrl_Cuda_Tile_List      *p_tile_elem;      

    cudaStream_t                    stream;

    void                            *p_device_data;

    cudaEvent_t                     kernel_last_read_event;
    cudaEvent_t                     kernel_last_write_event;

    cudaEvent_t                     offloading_last_read_event;
    cudaEvent_t                     offloading_last_write_event;

    cudaEvent_t                     host_last_read_event;
    cudaEvent_t                     host_last_write_event;

    int                             last_update;
} Ctrl_Cuda_Tile;

typedef struct Ctrl_Cuda_Tile_List {
	Ctrl_Cuda_Tile                *p_tile_ext;
    struct Ctrl_Cuda_Tile_List    *p_prev;
	struct Ctrl_Cuda_Tile_List    *p_next;
} Ctrl_Cuda_Tile_List;

#endif //_CTRL_CUDA_TILE_H_
