/*
 * <license>
 * 
 * Controller v2.1
 * 
 * This software is provided to enhance knowledge and encourage progress in the scientific
 * community. It should be used only for research and educational purposes. Any reproduction
 * or use for commercial purpose, public redistribution, in source or binary forms, with or 
 * without modifications, is NOT ALLOWED without the previous authorization of the copyright 
 * holder. The origin of this software must not be misrepresented; you must not claim that you
 * wrote the original software. If you use this software for any purpose (e.g. publication),
 * a reference to the software package and the authors must be included.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * Copyright (c) 2007-2020, Trasgo Group, Universidad de Valladolid.
 * All rights reserved.
 * 
 * More information on http://trasgo.infor.uva.es/
 * 
 * </license>
*/
#ifndef _CTRL_KERNEL_FPGA_CHAR_H_
#define _CTRL_KERNEL_FPGA_CHAR_H_

#ifndef CL_USE_DEPRECATED_OPENCL_1_2_APIS
#define CL_USE_DEPRECATED_OPENCL_1_2_APIS
#endif // CL_USE_DEPRECATED_OPENCL_1_2_APIS

#include <CL/cl.h>

#include <Kernel/Ctrl_KernelArgs.h>

#define CTRL_KERNEL_FPGA_KERNEL_CHAR( name, type, dims, ... ) \
		CTRL_KERNEL_FPGA_KERNEL_CHAR_##type( name, dims, __VA_ARGS__ )

/* Task kernel model */
#define CTRL_KERNEL_FPGA_KERNEL_CHAR_0( name, ... ) \
		size_t local_size_FPGA_##name[] = { 0, 0, 0 };

#define CTRL_KERNEL_FPGA_KERNEL_CHAR_1( name, dims, ... ) \
		CTRL_KERNEL_FPGA_KERNEL_CHAR_1_##dims( name, __VA_ARGS__ )

#define CTRL_KERNEL_FPGA_KERNEL_CHAR_1_1( name, X ) \
		size_t local_size_FPGA_##name[] = { X, 0, 0 };

#define CTRL_KERNEL_FPGA_KERNEL_CHAR_1_2( name, X, Y ) \
		size_t local_size_FPGA_##name[] = { X, Y, 0 };

#define CTRL_KERNEL_FPGA_KERNEL_CHAR_1_3( name, X, Y, Z ) \
		size_t local_size_FPGA_##name[] = { X, Y, Z };

#define CTRL_KERNEL_FPGA_KERNEL_CHAR_2( name, dims, A, B, C ) \
		size_t local_size_FPGA_##name[] = CTRL_KERNEL_FPGA_CHAR_##dims##A##B##C ;

#define CTRL_KERNEL_FPGA_CHAR_1defdefdef              { 256, 0, 0 };
#define CTRL_KERNEL_FPGA_CHAR_2defdefdef              { 256, 1, 0 };
#define CTRL_KERNEL_FPGA_CHAR_1mediumlowlow           { 128, 0, 0 };
#define CTRL_KERNEL_FPGA_CHAR_1fulllowlow             { 256, 0, 0 };
#define CTRL_KERNEL_FPGA_CHAR_2fulllowlow             { 128, 2, 0 };
#define CTRL_KERNEL_FPGA_CHAR_2square32lowlow         { 16, 16, 0 };
#define CTRL_KERNEL_FPGA_CHAR_2fullmediummedium       { 128, 2, 0 };
#define CTRL_KERNEL_FPGA_CHAR_2fulllowhigh            { 64, 3, 0 };
#define CTRL_KERNEL_FPGA_CHAR_2mediummediummedium     { 128, 2, 0 };
#define CTRL_KERNEL_FPGA_CHAR_2fixedsquare32          { 16, 16, 0 };
#define CTRL_KERNEL_FPGA_CHAR_2fixedsquare16          { 16, 16, 0 };
#define CTRL_KERNEL_FPGA_CHAR_2fixedsquare4           { 4, 4, 0 };
#define CTRL_KERNEL_FPGA_CHAR_2fixedsquare2           { 2, 2, 0 };

#endif // _CTRL_KERNEL_FPGA_CHAR_H_
