/*
 * <license>
 * 
 * Controller v2.1
 * 
 * This software is provided to enhance knowledge and encourage progress in the scientific
 * community. It should be used only for research and educational purposes. Any reproduction
 * or use for commercial purpose, public redistribution, in source or binary forms, with or 
 * without modifications, is NOT ALLOWED without the previous authorization of the copyright 
 * holder. The origin of this software must not be misrepresented; you must not claim that you
 * wrote the original software. If you use this software for any purpose (e.g. publication),
 * a reference to the software package and the authors must be included.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * Copyright (c) 2007-2020, Trasgo Group, Universidad de Valladolid.
 * All rights reserved.
 * 
 * More information on http://trasgo.infor.uva.es/
 * 
 * </license>
*/
#ifndef _CTRL_KERNEL_XPHI_ARGS_H_
#define _CTRL_KERNEL_XPHI_ARGS_H_

#include "Kernel/Ctrl_ImplType.h"
#include "Architectures/XPhi/Ctrl_XPhi_Tile.h"

#define CTRL_KERNEL_XPHI_KTILE_DEVICE_DATA( name ) \
    case CTRL_TYPE_XPHI : \
        k_##name.data = name->data; \
        break; 

#define STRINGIFY(a) #a

// FIXME: increment number of parameters for kernels -@ismael at 6/11/2018 12:04:39
// 
/* Macros to cast the data structures for offloading */
/*#define CAST_I_IN(type, name)		char *t_##name = name.data; int *orig_##name; orig_##name = (int*)(name.origAcumCard);
#define CAST_I_OUT(type, name)		char *t_##name = name.data; int *orig_##name; orig_##name = (int*)(name.origAcumCard);
#define CAST_I_IO(type, name)		char *t_##name = name.data; int *orig_##name; orig_##name = (int*)(name.origAcumCard);
#define CAST_I_INVAL(type, name)		

#define CAL_CAST_IN(role, type, name)			CAST_I_##role(type,name)	

#define CTRL_KERNEL_XPHI_CAST_HOST( list, numArgs, ... )       CAL_PROTO_CAST_IN_##numArgs( __VA_ARGS__ )

#define CAL_PROTO_CAST_IN_1( role, type, name )       CAL_CAST_IN(role, type, name)
#define CAL_PROTO_CAST_IN_2( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_1( __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_3( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_2( __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_4( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_3( __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_5( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_4( __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_6( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_5( __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_7( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_6( __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_8( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_7( __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_9( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_8( __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_10( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_9( __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_11( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_10( __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_12( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_11( __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_13( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_12( __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_14( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_13( __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_15( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_14( __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_16( role, type, name, ... )  CAL_CAST_IN(role, type, name) CAL_PROTO_CAST_IN_15( __VA_ARGS__ )
*/
/*#define CAST_I_IN(list, type, name)			\
		K##type k_##name;			\
		k_##name = *((K##type *)(list));	\
		char *t_##name = k_##name.data; 	\
		int *orig_##name; orig_##name = (int*)(k_##name.origAcumCard);*/
#define CAST_I_IN(list, type, name)			\
		K##type k_##name;			\
		k_##name = *((K##type *)(list));	\
		/*void *t_void_##name = (&k_##name)->data;*/ 	\
		void *t_void_##name = k_##name.data; 	\
		char *t_##name = (char *)t_void_##name; \
		int *orig_##name; orig_##name = (int*)(k_##name.origAcumCard);	\
		int *card_##name = (int*)(k_##name.card); //\
		printf(STRINGIFY( t_##name %p \n ), t_##name);		//\
		printf(STRINGIFY( origAcumCards = %i %i %i \n ), orig_##name[0], orig_##name[1], orig_##name[2], orig_##name[3]);		\
		int aaxg_##name = 0;			\
		for (aaxg_##name = 0; aaxg_##name < orig_##name[0]; aaxg_##name++)  \
			printf( STRINGIFY(value at t_##name [%i] = %f \n ), aaxg_##name, ((float *)t_##name)[aaxg_##name] );    \
		printf( STRINGIFY( name = %p %s ), (K##type *)(list), " ");		\
		printf( STRINGIFY( test1 = %f ), t_##name[0]);		\
		t_##name[0] = (float*)4;		\
		printf( STRINGIFY( k_##name = %p t_##name = %p orig_##name = %p ), &k_##name , t_##name , orig_##name ); 
#define CAST_I_OUT(list, type, name)			\
		K##type k_##name;			\
		k_##name = *((K##type *)(list));	\
		void *t_void_##name = (&k_##name)->data;\
		char *t_##name = (char *)t_void_##name; \
		int *orig_##name; orig_##name = (int*)(k_##name.origAcumCard); \
		int *card_##name = (int*)(k_##name.card); //\
		printf(STRINGIFY( t_##name %p \n ), t_##name);		//\
		printf( STRINGIFY( name = %p %s ), (K##type *)(list), " ");		\
		printf( STRINGIFY( test1 = %f ), t_##name[0]);		\
		printf( STRINGIFY( k_##name = %p t_##name = %p orig_##name = %p ), &k_##name , t_##name , orig_##name ); \
		printf( STRINGIFY( orig_acumCard_##name %i %i %i ), orig_##name[0], orig_##name[1], orig_##name[2] );
#define CAST_I_IO(list, type, name)			\
		K##type k_##name;			\
		k_##name = *((K##type *)(list));	\
		void *t_void_##name = k_##name.data; 	\
		char *t_##name = (char *)t_void_##name; \
		int *orig_##name; orig_##name = (int*)(k_##name.origAcumCard); \
		int *card_##name = (int*)(k_##name.card); //\
		printf( STRINGIFY( name = %p ), (K##type *)(list));		\
		printf( STRINGIFY( k_##name = %p t_##name = %p orig_##name = %p ), &k_##name , t_##name , orig_##name );
#define CAST_I_INVAL(list, type, name)			\
		type name = *((type *)(list));		//\
		printf( STRINGIFY( type name = %i ), name );
		//*((type *)(list)) = (*name);

#define CAL_CAST_IN( list, role, type, name )			CAST_I_##role( list, type, name )	

#define CTRL_KERNEL_XPHI_CAST_HOST( list, numArgs, ... )	CAL_PROTO_CAST_IN_##numArgs( list, __VA_ARGS__ )

#define CAL_PROTO_CAST_IN_1( list, role, type, name )       CAL_CAST_IN( list, role, type, name)
#define CAL_PROTO_CAST_IN_2( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_1( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_3( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_2( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_4( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_3( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_5( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_4( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_6( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_5( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_7( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_6( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_8( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_7( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_9( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_8( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_10( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_9( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_11( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_10( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_12( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_11( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_13( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_12( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_14( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_13( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_15( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_14( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )
#define CAL_PROTO_CAST_IN_16( list, role, type, name, ... )  CAL_CAST_IN( list, role, type, name) CAL_PROTO_CAST_IN_15( (uint8_t*)list + CTRL_KERNEL_LIST_SIZE_KTILE(role, type, name), __VA_ARGS__ )


#define CTRL_KERNEL_XPHI_GENSIGV_IN(type, name)						\
		int sig_write_##name = request.xphi.p_signals[sig_count]; sig_count++;	//\
		printf(STRINGIFY(Signal IN_##name write = %d ), sig_write_##name ); fflush(stdout); \
		printf("\n"); fflush(stdout);

#define CTRL_KERNEL_XPHI_GENSIGV_OUT(type, name)					\
		int sig_write_##name = request.xphi.p_signals[sig_count]; sig_count++;	\
		int sig_read_##name = request.xphi.p_signals[sig_count]; sig_count++;	//\
		printf(STRINGIFY(Signal OUT_##name write = %d read = %d ), sig_write_##name , sig_read_##name ); fflush(stdout); \
		printf("\n"); fflush(stdout);
#define CTRL_KERNEL_XPHI_GENSIGV_IO(type, name)						\
		int sig_write_##name = request.xphi.p_signals[sig_count]; sig_count++;	\
		int sig_read_##name = request.xphi.p_signals[sig_count]; sig_count++;	//\
		printf(STRINGIFY(Signal IO_##name write = %d read = %d ), sig_write_##name , sig_read_##name ); fflush(stdout); \
		printf("\n"); fflush(stdout);
#define CTRL_KERNEL_XPHI_GENSIGV_INVAL(type, name)		

#define CTRL_KERNEL_XPHI_GEN_SIGVAR(role, type, name)			CTRL_KERNEL_XPHI_GENSIGV_##role(type,name)		

#define CTRL_KERNEL_XPHI_GEN_SIGNALS( list, numArgs, ... )		\
		int sig_count = 0; 					\
		CTRL_KERNEL_XPHI_GEN_SIGNALS_##numArgs( __VA_ARGS__ )

#define CTRL_KERNEL_XPHI_GEN_SIGNALS_1( role, type, name )		CTRL_KERNEL_XPHI_GEN_SIGVAR(role, type, name)
#define CTRL_KERNEL_XPHI_GEN_SIGNALS_2( role, type, name, ... )		CTRL_KERNEL_XPHI_GEN_SIGVAR(role, type, name) CTRL_KERNEL_XPHI_GEN_SIGNALS_1( __VA_ARGS__ )
#define CTRL_KERNEL_XPHI_GEN_SIGNALS_3( role, type, name, ... )		CTRL_KERNEL_XPHI_GEN_SIGVAR(role, type, name) CTRL_KERNEL_XPHI_GEN_SIGNALS_2( __VA_ARGS__ )
#define CTRL_KERNEL_XPHI_GEN_SIGNALS_4( role, type, name, ... )		CTRL_KERNEL_XPHI_GEN_SIGVAR(role, type, name) CTRL_KERNEL_XPHI_GEN_SIGNALS_3( __VA_ARGS__ )
#define CTRL_KERNEL_XPHI_GEN_SIGNALS_5( role, type, name, ... )		CTRL_KERNEL_XPHI_GEN_SIGVAR(role, type, name) CTRL_KERNEL_XPHI_GEN_SIGNALS_4( __VA_ARGS__ )
#define CTRL_KERNEL_XPHI_GEN_SIGNALS_6( role, type, name, ... )		CTRL_KERNEL_XPHI_GEN_SIGVAR(role, type, name) CTRL_KERNEL_XPHI_GEN_SIGNALS_5( __VA_ARGS__ )
#define CTRL_KERNEL_XPHI_GEN_SIGNALS_7( role, type, name, ... )		CTRL_KERNEL_XPHI_GEN_SIGVAR(role, type, name) CTRL_KERNEL_XPHI_GEN_SIGNALS_6( __VA_ARGS__ )
#define CTRL_KERNEL_XPHI_GEN_SIGNALS_8( role, type, name, ... )		CTRL_KERNEL_XPHI_GEN_SIGVAR(role, type, name) CTRL_KERNEL_XPHI_GEN_SIGNALS_7( __VA_ARGS__ )


/* Macros to cast the data structures for offloading */
/*#define CAST_O_IN(type, name)		  \
		k_##name.data = t_##name; \
		k_##name.origAcumCard[0] = orig_##name[0]; k_##name.origAcumCard[1] = orig_##name[1]; \
		k_##name.origAcumCard[2] = orig_##name[2]; k_##name.origAcumCard[3] = orig_##name[3]; 

#define CAST_O_OUT(type, name)		  \
		k_##name.data = t_##name; \
		k_##name.origAcumCard[0] = orig_##name[0]; k_##name.origAcumCard[1] = orig_##name[1]; \
		k_##name.origAcumCard[2] = orig_##name[2]; k_##name.origAcumCard[3] = orig_##name[3]; 
#define CAST_O_IO(type, name)		  \
		k_##name.data = t_##name; \
		k_##name.origAcumCard[0] = orig_##name[0]; k_##name.origAcumCard[1] = orig_##name[1]; \
		k_##name.origAcumCard[2] = orig_##name[2]; k_##name.origAcumCard[3] = orig_##name[3]; 
#define CAST_O_INVAL(type, name)		*/
#define CAST_O_IN(type, name)		  \
		void* t_inner_##name = t_##name; \
		k_##name.data = t_inner_##name; \
		k_##name.origAcumCard[0] = orig_##name[0]; k_##name.origAcumCard[1] = orig_##name[1]; \
		k_##name.origAcumCard[2] = orig_##name[2]; k_##name.origAcumCard[3] = orig_##name[3]; \
		k_##name.card[0] = card_##name[0]; k_##name.card[1] = card_##name[1]; k_##name.card[2] = card_##name[2];

#define CAST_O_OUT(type, name)		  \
		void* t_inner_##name = t_##name; \
		k_##name.data = t_inner_##name; \
		k_##name.origAcumCard[0] = orig_##name[0]; k_##name.origAcumCard[1] = orig_##name[1]; \
		k_##name.origAcumCard[2] = orig_##name[2]; k_##name.origAcumCard[3] = orig_##name[3]; \
		k_##name.card[0] = card_##name[0]; k_##name.card[1] = card_##name[1]; k_##name.card[2] = card_##name[2];
#define CAST_O_IO(type, name)		  \
		void* t_inner_##name = t_##name; \
		k_##name.data = t_inner_##name; \
		k_##name.origAcumCard[0] = orig_##name[0]; k_##name.origAcumCard[1] = orig_##name[1]; \
		k_##name.origAcumCard[2] = orig_##name[2]; k_##name.origAcumCard[3] = orig_##name[3]; \
		k_##name.card[0] = card_##name[0]; k_##name.card[1] = card_##name[1]; k_##name.card[2] = card_##name[2];
#define CAST_O_INVAL(type, name)		

#define CAL_CAST_OUT(role, type, name)			CAST_O_##role(type,name)		

#define CTRL_KERNEL_XPHI_CAST_DEVICE( list, numArgs, ... )       CAL_PROTO_CAST_OUT_##numArgs( __VA_ARGS__ )
#define CAL_PROTO_CAST_OUT_1( role, type, name )       CAL_CAST_OUT(role, type, name)
#define CAL_PROTO_CAST_OUT_2( role, type, name, ... )  CAL_CAST_OUT(role, type, name) CAL_PROTO_CAST_OUT_1( __VA_ARGS__ )
#define CAL_PROTO_CAST_OUT_3( role, type, name, ... )  CAL_CAST_OUT(role, type, name) CAL_PROTO_CAST_OUT_2( __VA_ARGS__ )
#define CAL_PROTO_CAST_OUT_4( role, type, name, ... )  CAL_CAST_OUT(role, type, name) CAL_PROTO_CAST_OUT_3( __VA_ARGS__ )
#define CAL_PROTO_CAST_OUT_5( role, type, name, ... )  CAL_CAST_OUT(role, type, name) CAL_PROTO_CAST_OUT_4( __VA_ARGS__ )
#define CAL_PROTO_CAST_OUT_6( role, type, name, ... )  CAL_CAST_OUT(role, type, name) CAL_PROTO_CAST_OUT_5( __VA_ARGS__ )
#define CAL_PROTO_CAST_OUT_7( role, type, name, ... )  CAL_CAST_OUT(role, type, name) CAL_PROTO_CAST_OUT_6( __VA_ARGS__ )
#define CAL_PROTO_CAST_OUT_8( role, type, name, ... )  CAL_CAST_OUT(role, type, name) CAL_PROTO_CAST_OUT_7( __VA_ARGS__ )

/* Macros needed to perform the offloading in the Xeon Phi */
/*#define KTILE_OFFLOAD_INVAL(type, name)             in(name) 
#define KTILE_OFFLOAD_IN(type, name)                in(name) in(orig_##name:length(4)) in(t_##name:length(0) alloc_if(0) free_if(0))
#define KTILE_OFFLOAD_IO(type, name)                in(name) in(orig_##name:length(4)) in(t_##name:length(0) alloc_if(0) free_if(0))
#define KTILE_OFFLOAD_OUT(type, name)               in(name) in(orig_##name:length(4)) in(t_##name:length(0) alloc_if(0) free_if(0))
*/
//FIXME: Resolver qué pasa en la línea de abajo con los INVAL (como se sacan del args_list). Preguntar a @waxa
#define KTILE_OFFLOAD_INVAL(type, name)             in(name) 
#define KTILE_OFFLOAD_IN(type, name)                in(k_##name) in(orig_##name:length(4)) in(card_##name:length(3)) in(t_##name:length(0) align(64) alloc_if(0) free_if(0))
#define KTILE_OFFLOAD_IO(type, name)                in(k_##name) in(orig_##name:length(4)) in(card_##name:length(3)) in(t_##name:length(0) align(64) alloc_if(0) free_if(0))
#define KTILE_OFFLOAD_OUT(type, name)               in(k_##name) in(orig_##name:length(4)) in(card_##name:length(3)) in(t_##name:length(0) align(64) alloc_if(0) free_if(0))

#define CAL_OFFLOAD_KTILE(role,type, name)          KTILE_OFFLOAD_##role(type,name) 

#define CAL_PROTO_OFFLOAD_KTILE_1( role, type, name )       CAL_OFFLOAD_KTILE(role, type, name)
#define CAL_PROTO_OFFLOAD_KTILE_2( role, type, name, ... )  CAL_OFFLOAD_KTILE(role, type, name) CAL_PROTO_OFFLOAD_KTILE_1( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_KTILE_3( role, type, name, ... )  CAL_OFFLOAD_KTILE(role, type, name) CAL_PROTO_OFFLOAD_KTILE_2( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_KTILE_4( role, type, name, ... )  CAL_OFFLOAD_KTILE(role, type, name) CAL_PROTO_OFFLOAD_KTILE_3( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_KTILE_5( role, type, name, ... )  CAL_OFFLOAD_KTILE(role, type, name) CAL_PROTO_OFFLOAD_KTILE_4( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_KTILE_6( role, type, name, ... )  CAL_OFFLOAD_KTILE(role, type, name) CAL_PROTO_OFFLOAD_KTILE_5( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_KTILE_7( role, type, name, ... )  CAL_OFFLOAD_KTILE(role, type, name) CAL_PROTO_OFFLOAD_KTILE_6( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_KTILE_8( role, type, name, ... )  CAL_OFFLOAD_KTILE(role, type, name) CAL_PROTO_OFFLOAD_KTILE_7( __VA_ARGS__ )


#define CAL_PROTO_OFFLOAD_KTILE_R( list, numArgs, ... )             offload target(mic:0) in(threads) __VA_ARGS__
#define CTRL_KERNEL_XPHI_OFFLOAD_KTILE( list, numArgs, ... )        CAL_PROTO_OFFLOAD_KTILE_R( list, numArgs, CAL_PROTO_OFFLOAD_KTILE_##numArgs( __VA_ARGS__ ) )

/*beatbox*/
//Asynchronous MIC Kernel: Modified version of the CAL_PROTO_CAST_IN for asynchronous transfers: get the signals for each imput parameter
#define CAST_ASYNC_I_IN(type, name)		char *t_##name = name.data; int *orig_##name; orig_##name = (int*)(name.origAcumCard); int *sig_##name = (int *) 
#define CAST_ASYNC_I_OUT(type, name)		char *t_##name = name.data; int *orig_##name; orig_##name = (int*)(name.origAcumCard); int *sig_##name = (int *)
#define CAST_ASYNC_I_IO(type, name)		char *t_##name = name.data; int *orig_##name; orig_##name = (int*)(name.origAcumCard); int *sig_##name = (int *)
#define CAST_ASYNC_I_INVAL(type, name)		

#define CAL_CAST_ASYNC_IN(role, type, name)			CAST_ASYNC_I_##role(type,name)		

#define CTRL_KERNEL_XPHI_CAST_ASYNC_HOST( list, numArgs, ... )       CAL_PROTO_CAST_IN_##numArgs( __VA_ARGS__ )
#define CAL_PROTO_CAST_ASYNC_IN_1( role, type, name )       CAL_CAST_ASYNC_IN(role, type, name)
#define CAL_PROTO_CAST_ASYNC_IN_2( role, type, name, ... )  CAL_CAST_ASYNC_IN(role, type, name) CAL_PROTO_CAST_ASYNC_IN_1( __VA_ARGS__ )
#define CAL_PROTO_CAST_ASYNC_IN_3( role, type, name, ... )  CAL_CAST_ASYNC_IN(role, type, name) CAL_PROTO_CAST_ASYNC_IN_2( __VA_ARGS__ )
#define CAL_PROTO_CAST_ASYNC_IN_4( role, type, name, ... )  CAL_CAST_ASYNC_IN(role, type, name) CAL_PROTO_CAST_ASYNC_IN_3( __VA_ARGS__ )
#define CAL_PROTO_CAST_ASYNC_IN_5( role, type, name, ... )  CAL_CAST_ASYNC_IN(role, type, name) CAL_PROTO_CAST_ASYNC_IN_4( __VA_ARGS__ )
#define CAL_PROTO_CAST_ASYNC_IN_6( role, type, name, ... )  CAL_CAST_ASYNC_IN(role, type, name) CAL_PROTO_CAST_ASYNC_IN_5( __VA_ARGS__ )
#define CAL_PROTO_CAST_ASYNC_IN_7( role, type, name, ... )  CAL_CAST_ASYNC_IN(role, type, name) CAL_PROTO_CAST_ASYNC_IN_6( __VA_ARGS__ )
#define CAL_PROTO_CAST_ASYNC_IN_8( role, type, name, ... )  CAL_CAST_ASYNC_IN(role, type, name) CAL_PROTO_CAST_ASYNC_IN_7( __VA_ARGS__ )

//Asynchronous MIC Kernel: generate the signals corresponding to each tile (IN, OUT, IO) or a default, already used signal that holds a OFFLOAD_SUCCESS
// A signal can be reused multiple times inside a signal( ) clause.
#define WAIT_OFFLOAD_INVAL(type, name)              default_signal 
#define WAIT_OFFLOAD_IN(type, name)                 sig_write_##name
#define WAIT_OFFLOAD_IO(type, name)                 sig_write_##name, sig_read_##name 
#define WAIT_OFFLOAD_OUT(type, name)                sig_write_##name, sig_read_##name

#define CAL_OFFLOAD_WAIT(role,type, name)          WAIT_OFFLOAD_##role(type,name) 

#define CAL_PROTO_OFFLOAD_WAIT_1( role, type, name )		CAL_OFFLOAD_WAIT(role, type, name)
#define CAL_PROTO_OFFLOAD_WAIT_2( role, type, name, ... )	CAL_OFFLOAD_WAIT(role, type, name) , CAL_PROTO_OFFLOAD_WAIT_1( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_WAIT_3( role, type, name, ... )	CAL_OFFLOAD_WAIT(role, type, name) , CAL_PROTO_OFFLOAD_WAIT_2( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_WAIT_4( role, type, name, ... )	CAL_OFFLOAD_WAIT(role, type, name) , CAL_PROTO_OFFLOAD_WAIT_3( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_WAIT_5( role, type, name, ... )	CAL_OFFLOAD_WAIT(role, type, name) , CAL_PROTO_OFFLOAD_WAIT_4( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_WAIT_6( role, type, name, ... )	CAL_OFFLOAD_WAIT(role, type, name) , CAL_PROTO_OFFLOAD_WAIT_5( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_WAIT_7( role, type, name, ... )	CAL_OFFLOAD_WAIT(role, type, name) , CAL_PROTO_OFFLOAD_WAIT_6( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_WAIT_8( role, type, name, ... )	CAL_OFFLOAD_WAIT(role, type, name) , CAL_PROTO_OFFLOAD_WAIT_7( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_WAIT_9( role, type, name, ... )	CAL_OFFLOAD_WAIT(role, type, name) , CAL_PROTO_OFFLOAD_WAIT_8( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_WAIT_10( role, type, name, ... )	CAL_OFFLOAD_WAIT(role, type, name) , CAL_PROTO_OFFLOAD_WAIT_9( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_WAIT_11( role, type, name, ... )	CAL_OFFLOAD_WAIT(role, type, name) , CAL_PROTO_OFFLOAD_WAIT_10( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_WAIT_12( role, type, name, ... )	CAL_OFFLOAD_WAIT(role, type, name) , CAL_PROTO_OFFLOAD_WAIT_11( __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_WAIT_13( role, type, name, ... )	CAL_OFFLOAD_WAIT(role, type, name) , CAL_PROTO_OFFLOAD_WAIT_12( __VA_ARGS__ )
//#define CAL_PROTO_OFFLOAD_WAIT_13( role, type, name, ... )	CAL_OFFLOAD_WAIT(role, type, name) STRINGIFY(, ) CAL_PROTO_OFFLOAD_WAIT_12( __VA_ARGS__ )

//Asynchronous MIC Kernel: Avoid generating an empty wait clause when there is zero arguments
#define CAL_PROTO_OFFLOAD_WAIT_ARGCNT_0( numArgs, ... )
#define CAL_PROTO_OFFLOAD_WAIT_ARGCNT_1( numArgs, ... )		wait( CAL_PROTO_OFFLOAD_WAIT_##numArgs( __VA_ARGS__ ) ) 
#define CAL_PROTO_OFFLOAD_WAIT_ARGCNT_2( numArgs, ... )		wait( CAL_PROTO_OFFLOAD_WAIT_##numArgs( __VA_ARGS__ ) ) 
#define CAL_PROTO_OFFLOAD_WAIT_ARGCNT_3( numArgs, ... )		wait( CAL_PROTO_OFFLOAD_WAIT_##numArgs( __VA_ARGS__ ) ) 
#define CAL_PROTO_OFFLOAD_WAIT_ARGCNT_4( numArgs, ... )		wait( CAL_PROTO_OFFLOAD_WAIT_##numArgs( __VA_ARGS__ ) ) 
#define CAL_PROTO_OFFLOAD_WAIT_ARGCNT_5( numArgs, ... )		wait( CAL_PROTO_OFFLOAD_WAIT_##numArgs( __VA_ARGS__ ) ) 
#define CAL_PROTO_OFFLOAD_WAIT_ARGCNT_6( numArgs, ... )		wait( CAL_PROTO_OFFLOAD_WAIT_##numArgs( __VA_ARGS__ ) ) 
#define CAL_PROTO_OFFLOAD_WAIT_ARGCNT_7( numArgs, ... )		wait( CAL_PROTO_OFFLOAD_WAIT_##numArgs( __VA_ARGS__ ) ) 
#define CAL_PROTO_OFFLOAD_WAIT_ARGCNT_8( numArgs, ... )		wait( CAL_PROTO_OFFLOAD_WAIT_##numArgs( __VA_ARGS__ ) ) 
#define CAL_PROTO_OFFLOAD_WAIT_ARGCNT_9( numArgs, ... )		wait( CAL_PROTO_OFFLOAD_WAIT_##numArgs( __VA_ARGS__ ) ) 
#define CAL_PROTO_OFFLOAD_WAIT_ARGCNT_10( numArgs, ... )	wait( CAL_PROTO_OFFLOAD_WAIT_##numArgs( __VA_ARGS__ ) ) 
#define CAL_PROTO_OFFLOAD_WAIT_ARGCNT_11( numArgs, ... )	wait( CAL_PROTO_OFFLOAD_WAIT_##numArgs( __VA_ARGS__ ) ) 
#define CAL_PROTO_OFFLOAD_WAIT_ARGCNT_12( numArgs, ... )	wait( CAL_PROTO_OFFLOAD_WAIT_##numArgs( __VA_ARGS__ ) ) 
#define CAL_PROTO_OFFLOAD_WAIT_ARGCNT_13( numArgs, ... )	wait( CAL_PROTO_OFFLOAD_WAIT_##numArgs( __VA_ARGS__ ) )


//#define CAL_PROTO_OFFLOAD_KTILE_R_WAIT( numArgs, ... )                STRINGIFY(offload target(mic:0) in(threads) __VA_ARGS__ )
#define CAL_PROTO_OFFLOAD_KTILE_R_WAIT( numArgs, ... )                STRINGIFY(offload target(mic) in(threads) __VA_ARGS__ )
#define CTRL_KERNEL_XPHI_OFFLOAD_KTILE_ASYNC( stream_handler, wait_signal, numArgs, ... )        CAL_PROTO_OFFLOAD_KTILE_R_WAIT( numArgs, CAL_PROTO_OFFLOAD_KTILE_##numArgs( __VA_ARGS__ ) CAL_PROTO_OFFLOAD_WAIT_ARGCNT_##numArgs( numArgs, __VA_ARGS__ ) stream(stream_handler) signal(wait_signal) )

// #define CAL_PROTO_OFFLOAD_KTILE_R_WAIT( list, numArgs, ... )                offload target(mic:0) in(threads) __VA_ARGS__
// #define CTRL_KERNEL_XPHI_OFFLOAD_KTILE_ASYNC( list, numArgs, ... )        CAL_PROTO_OFFLOAD_KTILE_R_WAIT( list, numArgs, CAL_PROTO_OFFLOAD_KTILE_##numArgs( __VA_ARGS__ ) CAL_PROTO_OFFLOAD_WAIT_ARGCNT_##numArgs( numArgs, __VA_ARGS__ ) )

#define CTRL_KERNEL_ARG_LIST_KTILE_INNER_INVAL( type, name )		name
#define CTRL_KERNEL_ARG_LIST_KTILE_INNER_IN( type, name )		k_##name
#define CTRL_KERNEL_ARG_LIST_KTILE_INNER_IO( type, name )		k_##name
#define CTRL_KERNEL_ARG_LIST_KTILE_INNER_OUT( type, name )		k_##name

#define CTRL_KERNEL_ARG_LIST_KTILE_INNER(role, type, name)	CTRL_KERNEL_ARG_LIST_KTILE_INNER_##role(type, name) 

#define CTRL_KERNEL_ARG_LIST_KTILE( list, numArgs, ... )	CTRL_KERNEL_ARG_LIST_KTILE_##numArgs( __VA_ARGS__ )

#define CTRL_KERNEL_ARG_LIST_KTILE_1( role, type, name )                   \
                CTRL_KERNEL_ARG_LIST_KTILE_INNER(role, type, name) 
#define CTRL_KERNEL_ARG_LIST_KTILE_2( role, type, name, ... )      \
                CTRL_KERNEL_ARG_LIST_KTILE_INNER(role, type, name) , CTRL_KERNEL_ARG_LIST_KTILE_1( __VA_ARGS__ )
#define CTRL_KERNEL_ARG_LIST_KTILE_3( role, type, name, ... )      \
                CTRL_KERNEL_ARG_LIST_KTILE_INNER(role, type, name) , CTRL_KERNEL_ARG_LIST_KTILE_2( __VA_ARGS__ )
#define CTRL_KERNEL_ARG_LIST_KTILE_4( role, type, name, ... )      \
                CTRL_KERNEL_ARG_LIST_KTILE_INNER(role, type, name) , CTRL_KERNEL_ARG_LIST_KTILE_3( __VA_ARGS__ )
#define CTRL_KERNEL_ARG_LIST_KTILE_5( role, type, name, ... )      \
                CTRL_KERNEL_ARG_LIST_KTILE_INNER(role, type, name) , CTRL_KERNEL_ARG_LIST_KTILE_4( __VA_ARGS__ )
#define CTRL_KERNEL_ARG_LIST_KTILE_6( role, type, name, ... )      \
                CTRL_KERNEL_ARG_LIST_KTILE_INNER(role, type, name) , CTRL_KERNEL_ARG_LIST_KTILE_5( __VA_ARGS__ )
#define CTRL_KERNEL_ARG_LIST_KTILE_7( role, type, name, ... )      \
                CTRL_KERNEL_ARG_LIST_KTILE_INNER(role, type, name) , CTRL_KERNEL_ARG_LIST_KTILE_6( __VA_ARGS__ )
#define CTRL_KERNEL_ARG_LIST_KTILE_8( role, type, name, ... )      \
                CTRL_KERNEL_ARG_LIST_KTILE_INNER(role, type, name) , CTRL_KERNEL_ARG_LIST_KTILE_7( __VA_ARGS__ )
#define CTRL_KERNEL_ARG_LIST_KTILE_9( role, type, name, ... )      \
                CTRL_KERNEL_ARG_LIST_KTILE_INNER( role, type, name) , CTRL_KERNEL_ARG_LIST_KTILE_8( __VA_ARGS__ )

#endif // _CTRL_KERNEL_XPHI_ARGS_H_
