/*
 * <license>
 * 
 * Controller v2.1
 * 
 * This software is provided to enhance knowledge and encourage progress in the scientific
 * community. It should be used only for research and educational purposes. Any reproduction
 * or use for commercial purpose, public redistribution, in source or binary forms, with or 
 * without modifications, is NOT ALLOWED without the previous authorization of the copyright 
 * holder. The origin of this software must not be misrepresented; you must not claim that you
 * wrote the original software. If you use this software for any purpose (e.g. publication),
 * a reference to the software package and the authors must be included.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * Copyright (c) 2007-2020, Trasgo Group, Universidad de Valladolid.
 * All rights reserved.
 * 
 * More information on http://trasgo.infor.uva.es/
 * 
 * </license>
*/
#ifndef _CTRL_XPHI_KERNELPROTO_H_
#define _CTRL_XPHI_KERNELPROTO_H_

#include <stdio.h>

#include "Architectures/XPhi/Ctrl_XPhi_Request.h"
#include "Architectures/XPhi/Ctrl_XPhi_Tile.h"

#include "Kernel/Ctrl_KernelArgs.h"
#include "Kernel/Architectures/XPhi/Ctrl_XPhi_KernelArgs.h"
// #include "Kernel/Architectures/XPhi/Ctrl_XPhi_KernelUtils.h"
#include "Kernel/Ctrl_Thread.h"

//TODO @waxa lo de la funcion anterior que cargue el kernel y todo eso
#define CTRL_KERNEL_XPHI( name, type, ... ) \
	static void __attribute__((target(mic))) CTRL_KERNEL_##type##_##name (Ctrl_Thread thread_id, __VA_ARGS__ )
	//static void __attribute__((target(mic))) CTRL_KERNEL_##type##_##name(CALThread threadId, CAL_XPHI_KWRAPPER_PARAMS##nparams(params))
	//void CTRL_KERNEL_##type##_##name ( Ctrl_Thread thread_id, __VA_ARGS__ )




// #define CTRL_KERNEL_Generic(name,type, ...)		\
// 	__kernel void CTRL_KERNEL_##type##_##name ( Ctrl_Thread threadId, __VA_ARGS__ )

// Punto de entrada al lanzamiento (equivalente a global en cuda) (hay que guardarlo en una variable o argo)
#define LAUNCH_XPHI(name,  ...)				\
    void launch_XPhi_##name( Ctrl_Thread threads, CTRL_KERNEL_TYPED_KTILE( NULL, __VA_ARGS__ ) ) { }


#define CTRL_KERNEL_WRAP_XPHI( name, args_list, type, n_params, ... ) \
    { \
        _Offload_stream stream_handler = request.xphi.stream_handler;		\
	/*printf("CTRL_KERNEL_WRAP_XPHI\n"); fflush(stdout);*/			\
        int new_signal = request.xphi.new_signal;				\
        int default_signal = request.xphi.default_signal;			\
        int wait_signal = request.xphi.new_signal;				\
	/*TERMAC( name, args_list, type, n_params, __VA_ARGS__ )*/		\
        CTRL_KERNEL_XPHI_CAST_HOST( args_list, n_params, __VA_ARGS__ )		\
	CTRL_KERNEL_XPHI_GEN_SIGNALS( args_list, n_params, __VA_ARGS__ )	\
	/*printf(STRINGIFY(Signal Wait = %d ), wait_signal ); fflush(stdout); printf("\n"); fflush(stdout);*/ \
        _Pragma( CTRL_KERNEL_XPHI_OFFLOAD_KTILE_ASYNC( stream_handler, wait_signal, n_params, __VA_ARGS__ ) ) \
        { \
            CTRL_KERNEL_XPHI_CAST_DEVICE(args_list, n_params, __VA_ARGS__) \
            if (threads.z > 1) {  /* Executing in parallel the 3D threads */ \
                /*TODO @arturo numero de threads (depende del rango) */ \
                int i_aux; /*  private(i_aux, j_aux, k_aux)*/ \
                _Pragma("omp parallel for")  \
                for (i_aux = 0; i_aux < threads.x; i_aux++) { \
                    /*printf(" CTRL_KERNEL_WRAP_XPHI %d %d\n", i_aux, omp_get_thread_num()); \
                    fflush(stdout);*/ \
                    for (int j_aux = 0 ; j_aux < threads.y; j_aux++) { \
                        for( int k_aux = 0; k_aux < threads.z; k_aux++) { \
                            Ctrl_Thread thread_id; \
                            thread_id.x = i_aux; \
                            thread_id.y = j_aux; \
                            thread_id.z = k_aux; \
                            /*CTRL_KERNEL_XPHI_##name( thread_id, CTRL_KERNEL_ARG_LIST_ACCESS_KTILE( args_list, n_params, __VA_ARGS__ ) );*/ \
                            CTRL_KERNEL_XPHI_##name( thread_id, CTRL_KERNEL_ARG_LIST_KTILE( args_list, n_params, __VA_ARGS__ ) ); \
                        } \
                    } \
                } \
            } else if (threads.y > 1) { /* Executing in parallel the 2D threads */ \
                int i_aux; /*  private(i_aux, j_aux, k_aux)*/ \
                _Pragma("omp parallel for")  \
                for (i_aux = 0; i_aux < threads.x; i_aux++) { \
                    /*printf(" CTRL_KERNEL_WRAP_XPHI %d %d\n", i_aux, omp_get_thread_num()); \
                    fflush(stdout);*/ \
                    for (int j_aux = 0 ; j_aux < threads.y; j_aux++) { \
                        Ctrl_Thread thread_id; \
                        thread_id.x = i_aux; \
                        thread_id.y = j_aux; \
                        thread_id.z = 0; \
                        /*CTRL_KERNEL_XPHI_##name( thread_id, CTRL_KERNEL_ARG_LIST_ACCESS_KTILE( args_list, n_params, __VA_ARGS__ ) );*/ \
                        CTRL_KERNEL_XPHI_##name( thread_id, CTRL_KERNEL_ARG_LIST_KTILE( args_list, n_params, __VA_ARGS__ ) ); \
                    } \
                } \
            } else { /* Executing in parallel the 1D threads */ \
                int i_aux; /*  private(i_aux, j_aux, k_aux)*/ \
                _Pragma("omp parallel for") \
                for (i_aux = 0; i_aux < threads.x; i_aux++) { \
                    /*printf(" CTRL_KERNEL_WRAP_XPHI %d %d\n", i_aux, omp_get_thread_num()); \
                    fflush(stdout);*/ \
                    Ctrl_Thread thread_id; \
                    thread_id.x = i_aux; \
                    /*CTRL_KERNEL_XPHI_##name( thread_id, CTRL_KERNEL_ARG_LIST_ACCESS_KTILE( args_list, n_params, __VA_ARGS__ ) );*/ \
                    CTRL_KERNEL_XPHI_##name( thread_id, CTRL_KERNEL_ARG_LIST_KTILE( args_list, n_params, __VA_ARGS__ ) ); \
                } \
            } \
	} \
    }

#endif //_CTRL_XPHI_KERNELPROTO_H_
