/*
 * <license>
 * 
 * Controller v2.1
 * 
 * This software is provided to enhance knowledge and encourage progress in the scientific
 * community. It should be used only for research and educational purposes. Any reproduction
 * or use for commercial purpose, public redistribution, in source or binary forms, with or 
 * without modifications, is NOT ALLOWED without the previous authorization of the copyright 
 * holder. The origin of this software must not be misrepresented; you must not claim that you
 * wrote the original software. If you use this software for any purpose (e.g. publication),
 * a reference to the software package and the authors must be included.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDER AND CONTRIBUTORS "AS IS" AND ANY
 * EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF 
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL
 * THE AUTHORS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL,
 * EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
 * SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 * 
 * Copyright (c) 2007-2020, Trasgo Group, Universidad de Valladolid.
 * All rights reserved.
 * 
 * More information on http://trasgo.infor.uva.es/
 * 
 * </license>
*/
/*
 * Definitions for kernel implementations, and masks to identify the implementations
 * that fit in a device/launching requirement
 *
 * @version 1.0
 * @author Arturo Gonzalez-Escribano
 * @date Oct 2016
 */

#ifndef _CTRL_KERNEL_IMPLTYPE_H_
#define _CTRL_KERNEL_IMPLTYPE_H_

typedef enum {
		CPU,
		CPU_LIB,
		CUDA,
		CUDA_LIB,
		OPENCL_GPU,
		OPENCL_GPU_LIB,
		XPHI,
		XPHI_LIB,
		GENERIC,
		FPGA,
		FPGA_LIB
} Ctrl_ImplType;

#define CTRL_IMPLTYPE_SpCPU2			2
#define CTRL_IMPLTYPE_SpCPU				4
#define CTRL_IMPLTYPE_CPU_LIB			8
#define CTRL_IMPLTYPE_CPU				16

#define CTRL_IMPLTYPE_SpCUDA2			32
#define CTRL_IMPLTYPE_SpCUDA			64	
#define CTRL_IMPLTYPE_CUDA_LIB			128
#define CTRL_IMPLTYPE_CUDA				256

#define CTRL_IMPLTYPE_SpXphi2			512
#define CTRL_IMPLTYPE_SpXPhi			1024	
#define CTRL_IMPLTYPE_XPHI_LIB			2048
#define CTRL_IMPLTYPE_XPHI				4096

#define CTRL_IMPLTYPE_SpOPENCL2			8192
#define CTRL_IMPLTYPE_SpOPENCL			16384
#define CTRL_IMPLTYPE_OPENCL_GPU_LIB	32768
#define CTRL_IMPLTYPE_OPENCL_GPU		65536

#define CTRL_IMPLTYPE_GENERIC			131072

#define CTRL_IMPLTYPE_SpFPGA2			262144
#define CTRL_IMPLTYPE_SpFPGA			524288
#define CTRL_IMPLTYPE_FPGA				1048576
#define CTRL_IMPLTYPE_FPGA_LIB			2097152

#endif // _CTRL_KERNEL_IMPLTYPE_H_
