#!/bin/bash

CTRL_ROOT=../controller
HOTSPOT_PATH=${CTRL_ROOT}/build/experimentation/hotspot
CTRL_KERNEL_PATH=${CTRL_ROOT}/kernels/FPGA/Ctrl/Hotspot/
REF_KERNEL_PATH=${CTRL_ROOT}/kernels/FPGA/Ref/Hotspot

for pol in {0,1}; do
    if [ $pol == 0 ]
	then
		POLICY=Sync
	elif [ $pol == 1 ]
	then
		POLICY=Async
	fi

    Ctrl_make $POLICY

    for size in {1024,2048,3000,3500,4096}; do
        aocl program acl0 $CTRL_KERNEL_PATH/Hotspot_Ctrl.aocx

        mkdir -p Ctrl/hotspot/
        for i in  {1..10}; do
            for n_iters in {100,300,500}; do
                    env CL_CONTEXT_COMPILER_MODE_INTELFPGA=3 $HOTSPOT_PATH/Hotspot_Ctrl $size 1 $n_iters 1 0 1 ${pol} 0 >> Ctrl/hotspot/hotspot_$size-$n_iters-Ctrl-$POLICY-v20_1.log
            done
        done

        aocl program acl0 $REF_KERNEL_PATH/Hotspot_Ref.aocx

        mkdir -p Ref/hotspot/
        for i in  {1..10}; do
            for n_iters in {100,300,500}; do
                if [ $pol == 0 ]
                then
                    env CL_CONTEXT_COMPILER_MODE_INTELFPGA=3 $HOTSPOT_PATH/Hotspot_Ref_Sync $size 1 $n_iters 1 0 1 0 >> /Ref/hotspot/hotspot_$size-$n_iters-Ref$POLICY-v20_1.log
                elif [ $pol == 1 ]
                then
                    env CL_CONTEXT_COMPILER_MODE_INTELFPGA=3 $HOTSPOT_PATH/Hotspot_Ref_Async $size 1 $n_iters 1 0 1 0 >> Ref/hotspot/hotspot_$size-$n_iters-Ref$POLICY-v20_1.log
                fi
            done
        done
    done
done




