#!/bin/bash

CTRL_ROOT=../controller
MULT_PATH=${CTRL_ROOT}/build/experimentation/matrix-pow

POLICY=Sync
for pol in {0,1}; do
	if [ $pol == 0 ]
	then
		POLICY=Sync
	elif [ $pol == 1 ]
	then
		POLICY=Async
	fi

	Ctrl_make $POLICY

	aocl program acl0 ${CTRL_ROOT}/kernels/FPGA/Ctrl/Mult/Mult_SIMD-4-64x64x1_Ctrl.aocx
	for i in  {1..10}; do
	    for size in {640,1280,1920,2560}; do
	        for n_iters in {10,20,30}; do
	            env CL_CONTEXT_COMPILER_MODE_INTELFPGA=3 ${MULT_PATH}/Matrix_Pow_Ctrl $size $n_iters 0 1 ${pol} 0 >> Ctrl/matrix-pow/matrix-pow-$n_iters-Ctrl-$POLICY-v20_1.log
	        done 
	    done
	done

	aocl program acl0 ${CTRL_ROOT}/kernels/FPGA/Ref/Mult/Mult_SIMD-4-64x64x1_Ref.aocx
	for i in  {1..10}; do
	    for size in {640,1280,1920,2560}; do
	        for n_iters in {10,20,30}; do
				if [ $pol == 0 ]
				then
					env CL_CONTEXT_COMPILER_MODE_INTELFPGA=3 ${MULT_PATH}/Matrix_Pow_Ref_Sync $size $n_iters 0 1 0 >> Ref/matrix-pow/matrix-pow-$n_iters-Ref-$POLICY-v20_1.log
				elif [ $pol == 1 ]
					env CL_CONTEXT_COMPILER_MODE_INTELFPGA=3 ${MULT_PATH}/Matrix_Pow_Ref_Async $size $n_iters 0 1 0 >> Ref/matrix-pow/matrix-pow-$n_iters-Ref-$POLICY-v20_1.log
				fi
	        done 
	    done
	done
done