#!/bin/bash
CTRL_ROOT=../controller
RESULTS=../results
IN_FILE=~/Controllers/data/BigBuckBunny_1920_1080_24fps_Small.yuv
OUT_FILE=~/Controllers/data/BBB_out.avi
SOBEL_PATH=${CTRL_ROOT}/build/experimentation/sobel-yuv
CTRL_KERNEL_PATH=${CTRL_ROOT}/kernels/FPGA/Ctrl/Sobel_Operation
REF_KERNEL_PATH=${CTRL_ROOT}/kernels/FPGA/Ref/Sobel_Operation

FRAMES=(120 240 300 360)

for pol in {0,1}; do
	if [ $pol == 0 ]
	then
		POLICY=Sync
	elif [ $pol == 1 ]
	then
		POLICY=Async
	fi

	Ctrl_make $POLICY

	aocl program acl0 $CTRL_KERNEL_PATH/Sobel_Operation_Ctrl.aocx

	mkdir -p Ctrl/sobel-yuv/
	for i in  {1..10}; do
		for n_frames in ${FRAMES[@]}; do
			env CL_CONTEXT_COMPILER_MODE_INTELFPGA=3 ${SOBEL_PATH}/Sobel_YUV_Ctrl4 1920 1080 $n_frames ${IN_FILE} ${OUT_FILE} 0 1 ${pol} 0 >> Ctrl/sobel-yuv/sobel-yuv-1920x1080-Ctrl-$POLICY-FPGA-v20_1.log
		done 
	done

	mkdir -p $Ref/sobel-yuv/
	aocl program acl0 $REF_KERNEL_PATH/Sobel_Operation_Ref.aocx
	for i in  {1..10}; do
		for n_frames in ${FRAMES[@]}; do
			if [ $pol == 0 ]
			then
				env CL_CONTEXT_COMPILER_MODE_INTELFPGA=3 $SOBEL_PATH/Sobel_YUV_Ref_Sync 1920 1080 $n_frames ${IN_FILE} ${OUT_FILE} 0 1 0 >> Ref/sobel-yuv/sobel-yuv-1920x1080-Ref-$POLICY-FPGA-v20_1.log
			elif [ $pol == 1 ]
			then
				env CL_CONTEXT_COMPILER_MODE_INTELFPGA=3 $SOBEL_PATH/Sobel_YUV_Ref_Async 1920 1080 $n_frames ${IN_FILE} ${OUT_FILE} 0 1 0 >> Ref/sobel-yuv/sobel-yuv-1920x1080-Ref-$POLICY-FPGA-v20_1.log
			fi
		done 
	done

done
